; MCURVECHANGE.PRO
;
; Modal widget dialog that ceases operation of the calling widget program and
; passes out the new data upon exiting.
;
; Written by R.M. Dimeo (11/25/02)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro mccEvent,event
widget_control,event.top,get_uvalue = pInfo
uname = widget_info(event.id,/uname)
if uname eq 'DONE' then begin
  widget_control,(*pInfo).curveGroup,get_value = index
  if index eq 0 then begin	; SIN
  	(*pInfo).data[*,1] = sin((*pInfo).data[*,0])
  endif else begin	; COS
  	(*pInfo).data[*,1] = cos((*pInfo).data[*,0])
  endelse
  widget_control,event.top,/destroy
endif
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function mCurveChange,parent = parent,x
if n_elements(parent) eq 0 then begin
  parent = 0L
  modal = 0
endif else begin
  modal = 1
endelse
tlb = widget_base(group_leader = parent,modal = modal,/col)
curveType = ['sin(x)','cos(x)']
curveGroup = cw_bgroup(tlb, curveType, /col, /exclusive,$
         label_top='Curve Type',/no_release,$
         frame=1,set_value=0,/return_index,uname = 'CURVEGROUP')
void = widget_button(tlb,value = 'DONE',uname = 'DONE')
widget_control,tlb,/realize
y = fltarr(n_elements(x))
data = [[x],[y]]

info = {	curveGroup:curveGroup,	$
			data:data	$
		}

pInfo = ptr_new(info,/no_copy)
widget_control,tlb,set_uvalue = pInfo
; Since this is a modal widget program, no actions will occur
; past this xmanager call until the DONE button is pressed.
xmanager,'mcurvechange',tlb,event_handler = 'mccEvent'

data = (*pInfo).data
ptr_free,pInfo
return,data

end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;